searchData={"items":[{"type":"module","title":"One9.Ms","doc":"Operations on simple non-struct multiplicity maps (\"multisets\", `t:t/1``).\n\n\"Non-well-formed\" multisets include some entries for absent elements (`%{\"damn\" => 0}`),\nand may be accepted for certain operations for convenience.","ref":"One9.Ms.html"},{"type":"function","title":"One9.Ms.at/2","doc":"","ref":"One9.Ms.html#at/2"},{"type":"function","title":"One9.Ms.count/1","doc":"Return the cardinality of a multiset.\n\nInput *may* be non-well-formed.\n\nSee also `support_count/1`.","ref":"One9.Ms.html#count/1"},{"type":"function","title":"One9.Ms.count_element/2","doc":"Determine the multiplicity of an element in a multiset.\n\nInput *may* be non-well-formed.","ref":"One9.Ms.html#count_element/2"},{"type":"function","title":"One9.Ms.delete/3","doc":"","ref":"One9.Ms.html#delete/3"},{"type":"function","title":"One9.Ms.difference/2","doc":"","ref":"One9.Ms.html#difference/2"},{"type":"function","title":"One9.Ms.difference!/2","doc":"","ref":"One9.Ms.html#difference!/2"},{"type":"function","title":"One9.Ms.from_counts/1","doc":"Create a well-formed multiset from any (finite) Enumerable of `{t:term/0, t:non_neg_integer/0}` tuples.\n\nDuplicate entries for the same element are accepted, and will be folded in additively.","ref":"One9.Ms.html#from_counts/1"},{"type":"function","title":"Usage - One9.Ms.from_counts/1","doc":"iex> One9.Ms.from_counts([a: 2, b: 1, c: 10, c: 0, a: 1])\n    %{a: 3, b: 1, c: 10}\n\n    iex> One9.Ms.from_counts(%{a: 2, b: 1, c: 0})\n    %{a: 2, b: 1}","ref":"One9.Ms.html#from_counts/1-usage"},{"type":"function","title":"One9.Ms.from_elements/1","doc":"Create a well-formed multiset from any (finite) Enumerable of values.","ref":"One9.Ms.html#from_elements/1"},{"type":"function","title":"Usage - One9.Ms.from_elements/1","doc":"iex> One9.Ms.from_elements([:a, :a, :b, :c])\n    %{a: 2, b: 1, c: 1}","ref":"One9.Ms.html#from_elements/1-usage"},{"type":"function","title":"One9.Ms.intersection/2","doc":"","ref":"One9.Ms.html#intersection/2"},{"type":"function","title":"One9.Ms.member?/2","doc":"Determine whether a value is present at all in a multiset.\n\nInput *must* be well-formed.\n\nSee also `count_element/2`.","ref":"One9.Ms.html#member?/2"},{"type":"function","title":"One9.Ms.put/3","doc":"","ref":"One9.Ms.html#put/3"},{"type":"function","title":"One9.Ms.slice/1","doc":"","ref":"One9.Ms.html#slice/1"},{"type":"function","title":"One9.Ms.subset?/2","doc":"Determine whether the first multiset is a (non-strict) subset of the second.\n\nFirst operand must be well-formed.","ref":"One9.Ms.html#subset?/2"},{"type":"function","title":"One9.Ms.sum/2","doc":"","ref":"One9.Ms.html#sum/2"},{"type":"function","title":"One9.Ms.support/1","doc":"Convert a multiset into a List of unique elements.\n\nInput *must* be well-formed.","ref":"One9.Ms.html#support/1"},{"type":"function","title":"One9.Ms.support_count/1","doc":"Return the cardinality of the support of a multiset.\n\nArgument must be well-formed.\n\nSee also `count/1`.","ref":"One9.Ms.html#support_count/1"},{"type":"function","title":"One9.Ms.symmetric_difference/2","doc":"","ref":"One9.Ms.html#symmetric_difference/2"},{"type":"type","title":"One9.Ms.t0/0","doc":"","ref":"One9.Ms.html#t:t0/0"},{"type":"type","title":"One9.Ms.t0/1","doc":"","ref":"One9.Ms.html#t:t0/1"},{"type":"type","title":"One9.Ms.t/0","doc":"","ref":"One9.Ms.html#t:t/0"},{"type":"type","title":"One9.Ms.t/1","doc":"","ref":"One9.Ms.html#t:t/1"},{"type":"type","title":"One9.Ms.t_lax/0","doc":"","ref":"One9.Ms.html#t:t_lax/0"},{"type":"type","title":"One9.Ms.t_lax/1","doc":"","ref":"One9.Ms.html#t:t_lax/1"},{"type":"function","title":"One9.Ms.take/3","doc":"","ref":"One9.Ms.html#take/3"},{"type":"function","title":"One9.Ms.to_enumerable/1","doc":"","ref":"One9.Ms.html#to_enumerable/1"},{"type":"function","title":"One9.Ms.to_list/1","doc":"Convert a multiset into a complete List of elements (including repeats).\n\nInput *may* be non-well-formed.","ref":"One9.Ms.html#to_list/1"},{"type":"function","title":"One9.Ms.union/2","doc":"Return the union of two multisets.\n\nEither/both operands *may* be non-well-formed.\nResult will be well-formed whenever both operands are well-formed.","ref":"One9.Ms.html#union/2"},{"type":"module","title":"One9.Multiset","doc":"An unordered multiplicitous container type.","ref":"One9.Multiset.html"},{"type":"function","title":"One9.Multiset.count/1","doc":"Return the cardinality of a Multiset.\n\nSee also `support_count/1`.","ref":"One9.Multiset.html#count/1"},{"type":"function","title":"One9.Multiset.count_element/2","doc":"","ref":"One9.Multiset.html#count_element/2"},{"type":"function","title":"One9.Multiset.delete/3","doc":"","ref":"One9.Multiset.html#delete/3"},{"type":"function","title":"One9.Multiset.difference/2","doc":"Return the first Multiset less any copies of elements the second Multiset shares.\n\nThis difference is \"soft\" or \"clamping\". See also `difference!/1`.","ref":"One9.Multiset.html#difference/2"},{"type":"function","title":"One9.Multiset.difference!/2","doc":"Return the first Multiset less any copies of elements the second Multiset shares.\n\nRaises if the first Multiset is not a subset of the second. See also `difference/1`.","ref":"One9.Multiset.html#difference!/2"},{"type":"function","title":"One9.Multiset.from_counts/1","doc":"Create a Multiset from any (finite) Enumerable of `{t:term/0, t:non_neg_integer/0}` tuples.\n\nDuplicate entries for the same element are accepted, and will be folded in additively.","ref":"One9.Multiset.html#from_counts/1"},{"type":"function","title":"Usage - One9.Multiset.from_counts/1","doc":"iex> One9.Multiset.from_counts(%{a: 2, b: 1, c: 10})\n    One9.Multiset.new([:a, :a, :b, :c, :c, :c, :c, :c, :c, :c, :c, :c, :c])\n\n    iex> One9.Multiset.from_counts([a: 2, b: 1, c: 0, a: 1])\n    One9.Multiset.new([:a, :a, :a, :b])","ref":"One9.Multiset.html#from_counts/1-usage"},{"type":"function","title":"One9.Multiset.from_elements/1","doc":"Create a Multiset from any (finite) Enumerable of values.","ref":"One9.Multiset.html#from_elements/1"},{"type":"function","title":"Usage - One9.Multiset.from_elements/1","doc":"iex> One9.Multiset.from_elements(MapSet.new([0, 1, 1, 2, 3, 5, 8]))\n    One9.Multiset.new([0, 1, 2, 3, 5, 8])\n\n    iex> One9.Multiset.from_elements([0, 1, 1, 2, 3, 5, 8])\n    One9.Multiset.new([0, 1, 1, 2, 3, 5, 8])","ref":"One9.Multiset.html#from_elements/1-usage"},{"type":"opaque","title":"One9.Multiset.internal/1","doc":"","ref":"One9.Multiset.html#t:internal/1"},{"type":"function","title":"One9.Multiset.intersection/2","doc":"Return the intersection of two Multisets.","ref":"One9.Multiset.html#intersection/2"},{"type":"function","title":"One9.Multiset.member?/2","doc":"","ref":"One9.Multiset.html#member?/2"},{"type":"function","title":"One9.Multiset.new/1","doc":"Create a Multiset from a MapSet, List of elements, or Map of multiplicities.\n\nTo construct a Multiset from any other type, use `from_counts/1` or `from_elements/1` instead.","ref":"One9.Multiset.html#new/1"},{"type":"function","title":"Usage - One9.Multiset.new/1","doc":"iex> One9.Multiset.new(MapSet.new([0, 1, 1, 2, 3, 5, 8]))\n    One9.Multiset.new([0, 1, 2, 3, 5, 8])\n\n    iex> One9.Multiset.new([0, 1, 1, 2, 3, 5, 8])\n    One9.Multiset.new([0, 1, 1, 2, 3, 5, 8])\n\n    iex> One9.Multiset.new(%{a: 2, b: 1, c: 1})\n    One9.Multiset.new([:a, :a, :b, :c])\n\n    iex> One9.Multiset.new(%{a: 2, b: 1, c: 10})\n    One9.Multiset.new([:a, :a, :b, :c, :c, :c, :c, :c, :c, :c, :c, :c, :c])\n\n    iex> One9.Multiset.new(%{a: 2, b: 1, c: 10**100})\n    # alternate Inspect representation kicks in approximately when\n    # the cardinality of a Multiset exceeds\n    # the square of the cardinality of its support\n    One9.Multiset.from_counts(%{a: 2, b: 1, c: 10000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000})","ref":"One9.Multiset.html#new/1-usage"},{"type":"function","title":"One9.Multiset.put/3","doc":"","ref":"One9.Multiset.html#put/3"},{"type":"function","title":"One9.Multiset.slice/1","doc":"","ref":"One9.Multiset.html#slice/1"},{"type":"function","title":"One9.Multiset.subset?/2","doc":"Determine whether the first Multiset is a (non-strict) subset of the second.","ref":"One9.Multiset.html#subset?/2"},{"type":"function","title":"One9.Multiset.sum/2","doc":"Return the sum of two Multisets.","ref":"One9.Multiset.html#sum/2"},{"type":"function","title":"One9.Multiset.support/1","doc":"Convert a Multiset into a List of unique elements.","ref":"One9.Multiset.html#support/1"},{"type":"function","title":"One9.Multiset.support_count/1","doc":"Return the cardinality of the support of a Multiset.\n\nSee also `count/1`.","ref":"One9.Multiset.html#support_count/1"},{"type":"function","title":"One9.Multiset.symmetric_difference/2","doc":"","ref":"One9.Multiset.html#symmetric_difference/2"},{"type":"function","title":"Example - One9.Multiset.symmetric_difference/2","doc":"iex> One9.Multiset.symmetric_difference(\n    ...>   One9.Multiset.new(%{a: 10, b:  2, c: 1}),\n    ...>   One9.Multiset.new(%{a:  3, b: 10, c: 1})\n    ...> )\n    One9.Multiset.from_counts(%{a: 7, b: 8})","ref":"One9.Multiset.html#symmetric_difference/2-example"},{"type":"type","title":"One9.Multiset.t/0","doc":"","ref":"One9.Multiset.html#t:t/0"},{"type":"type","title":"One9.Multiset.t/1","doc":"","ref":"One9.Multiset.html#t:t/1"},{"type":"function","title":"One9.Multiset.take/3","doc":"","ref":"One9.Multiset.html#take/3"},{"type":"function","title":"One9.Multiset.to_counts/1","doc":"Convert a Multiset into a simple Map of elements to their multiplicities.","ref":"One9.Multiset.html#to_counts/1"},{"type":"function","title":"One9.Multiset.to_enumerable/1","doc":"","ref":"One9.Multiset.html#to_enumerable/1"},{"type":"function","title":"One9.Multiset.to_list/1","doc":"Convert a Multiset into a complete List of elements (including repeats).","ref":"One9.Multiset.html#to_list/1"},{"type":"function","title":"One9.Multiset.union/2","doc":"Return the union of two Multisets.","ref":"One9.Multiset.html#union/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.0"}}